#!/usr/local/etc/phpbin/phpbin
<?
require_once "../../../vars.inc.php";
require $ROOT_FOLDER."connect_io.php";
require $ADMIN_FOLDER."CheckUserFunctions.inc.php";
require ("function.inc.php");

//DBConnect();

list($VERSION_ID,$SYSTEM_ID) = $db->get_row("SELECT VersionNumber,SystemID FROM Settings",ARRAY_N);

if (!isset($phase)) $phase=1;

if (file_exists($TMP_FOLDER.$argv[1].".tgz"))
{
    $command = "tar zxvf ".$TMP_FOLDER.$argv[1].".tgz -C $TMP_FOLDER";
    system ($command);
}
else
{
    print "Patch file not found. Installation aborted.\n";
    exit;
}

if (!CheckDeps () ) InstallationAborted ();

if ($VersionID != $VERSION_ID) {
    print "Wrong version of NetCat.\n";
    InstallationAborted ();
}

if ($SystemID != $SYSTEM_ID) {
    print "Wrong version of NetCat.\n";
    InstallationAborted ();
}

if ( IsAlreadyInstalled () ) {
    print "Patch is already installed.\n";
    InstallationAborted ();
}

$InstallFile = $TMP_FOLDER."install.inc.php";
if (!is_readable ($InstallFile) ) {
    print "Cannot open file install.inc.php.\n";
    InstallationAborted ();
} else {
    require $InstallFile;
}

if (!is_readable ($TMP_FOLDER."id.txt") ) {
    print "Cannot open file id.txt.\n";
    InstallationAborted ();
}

if (!is_readable ($TMP_FOLDER."files.txt") ) {
    print "Cannot open file files.txt.\n";
    InstallationAborted ();
}

if (!is_readable ($TMP_FOLDER."sql.txt") ) {
    print "Cannot open file sql.txt.\n";
    InstallationAborted ();
}

if (!is_readable ($TMP_FOLDER."required.txt") ) {
    print "Cannot open file required.txt.\n";
    InstallationAborted ();
}

if (!is_readable ($TMP_FOLDER."symlinks.txt") ) {
    print "Cannot open file symlinks.txt.<br>\n";
    InstallationAborted ();
}


$Ability = CheckAbilityOfInstallation ();
if ($Ability["Success"] == 0) {
    print "Error: ".$Ability["ErrorMessage"].".\n";
    InstallationAborted ();
}

$Install = InstallPatch ();
if ($Install["Success"] == 0) {
    print "Error installing patch: ".$Install["ErrorMessage"].".\n";
    InstallationAborted ();
}

CopyFiles ();
ExecSQL ($TMP_FOLDER."sql.txt");
CreatLinks ();

$insert = "insert into Patch (Patch_Name,Created,Description) values ('$PatchName','".date('Ymd')."','$Description')";
$db->query ($insert);

DeleteTmpFiles ();
print "Patch successfully installed.\n";

?>